#ifndef SP_MATHLIN_H
#define SP_MATHLIN_H

/* Il s agit du module gerant les systemes d equations lineaires */
#include <vector>
#include <list>
using namespace std;

class Sp_Vector_lin;
class Sp_System_lin;

#include <math.h>
#include "sp_math.h"

// vecteur a 4 valeur: represente ax+by+cz+d=0
// On represente v[0]x+v[1]y+v[2]z+v[3]=0
class Sp_Vector_lin{
 public:
  
  // les contructeurs
  Sp_Vector_lin(float a,float b,float c,float d);
  Sp_Vector_lin(Sp_Plan p);

  // Affiche
  void Print();
  
  // les fonctions membres
  // met a un un coef d une ligne
  // attention le coef doit etre non nul
  void Uno(int i);

  /* teste vecteur nul */
  /* 0:vecteur nul 1:vecteur non nul */
  int IsNull();
  
  // liste de float
  float v[4];  
};



class Sp_System_lin {
 public:
  // les constructeurs
  Sp_System_lin();

  // Affiche
  void Print();
  
  // les fonctions membres
  void Add(Sp_Vector_lin *);

  // Echange des lignes
  void Echange_line(int j,int k);

  // Annule une ligne
  void Annule_ligne(int ligne_i,int colonne_i,int ligne_j);

  // Trouve une ligne a partir de la ligne k ou les coefs[i] sont non nuls
  // renvoie -1 si il n en existe pas
  int Find_line(int col,int lig);
  int Find_line2(int col,int lig);

  // Triangulise une matrice
  void Triangulise();
  // une passe pour trianguler
  int Triangulise_passe(int lig,int col);
  int Triangulise_passe2(int lig,int col);

  // donne le vecteur solution
  Sp_Point Solution(int &);
  
  // les variables
  vector<Sp_Vector_lin *> liste;
  int size;
};

/* Classes pour resoudre les equations du second degre */
class Sp_Eq2dg
{
 public:

  // les fonctions membres
  // le constructeur
  Sp_Eq2dg(float a1,float b1,float c1);
  // calcule les solutions
  void Solution();
  // ajoute une solution
  void Add(float);
  // affiche les solutions
  void Print();

  // les variables membres
  // la liste des solutions
  list<float> solution;
  // les coefs ax2+bx+c=0
  float a;
  float b;
  float c;  
};



// Les intersections
class Intersection
{
public:
  // le constructeur
  Intersection(Sp_Droite &,Sp_Sphere &);
  Intersection(Sp_Plan &,Sp_Plan &);
  Intersection(Sp_Droite &,Sp_Plan &);
  // une fonction utile
  void function1(Sp_Plan &plan1,Sp_Plan &plan2,Sp_Vecteur &);
  
  // Les donnees membres
  list<Sp_Point> liste_points;
  list<Sp_Droite> liste_droites;
};

#endif
