#ifndef __CMATH_H
#define __CMATH_H

#include <stdio.h>
#include <stdlib.h>
#include "sp_math.h"

/*  LES NOUVELLES CLASSES POUR SPACE RACER 2000  */ 


class Sp_Mat4;




class Sp_Mat4
{
 public:
  // le constructeur
  Sp_Mat4();
  Sp_Mat4(float *t);
  // la copy
  //void operator=(Sp_Mat4 &);
  Sp_Mat4 &operator=(const Sp_Mat4 &);
  // Set a Id
  void Id();
  // Set et Get
  void Set(float *);
  void Set(const Sp_Vecteur &i,const Sp_Vecteur &j,const Sp_Vecteur &k,const Sp_Point &O);
  void Get(float *);
  // La translation
  void Trans(float x,float y,float z);
  // Set de Mat de rotation
  void SetX(float);
  void SetY(float);
  void SetZ(float);
  // pour le traduire en open gl
  Sp_Mat4 put() const;
  // la mult
  Sp_Mat4 operator*(const Sp_Mat4 &) const;
  // l inverse
  Sp_Mat4 Inverse() const;
  // Affiche
  void Print();
  // les donnees
  float *tab;
};


#endif
