
#include "loadgl.h"
#include "../../data/sracer2006.h"



#define NB_PT_CONTOUR 8
//#define UNE_FACE_SUR_2  1
// nb d elements a dessiner
#define CST 23040
#define SCALE 5.0



__indice_list::__indice_list(int nb)
{
    nb_points=nb;
}

void __indice_list::Add_Indice(unsigned int ind)
{
    liste_indices.push_back(ind);
}

void __indice_list::Rem_Indice(unsigned int ind)
{
    liste_indices.remove(ind);
}

int __indice_list::isIndiceInList(unsigned int ind)
{
    typedef list<unsigned int>::iterator iter;
    for(iter j=liste_indices.begin();j!=liste_indices.end();j++)
    {
        if((ind%nb_points)==(*j))
            return 1;
    }
    return 0;
}

unsigned int *__indice_list::select_face_in(unsigned int *data,int nb_faces,int *nb_trouve)
{
    int i,nb;
    unsigned int *new_data;
    new_data=new unsigned int[nb_faces*3];
    
    nb=0;
    for(i=0;i<nb_faces;i++)
    {
      if(isIndiceInList(data[3*i+0])==0)
          continue;
      if(isIndiceInList(data[3*i+1])==0)
          continue;
      if(isIndiceInList(data[3*i+2])==0)
          continue;
          // Les trois indices y sont
      new_data[nb*3]=data[3*i+0];
      new_data[nb*3+1]=data[3*i+1];
      new_data[nb*3+2]=data[3*i+2];
      nb++;
    }
    *nb_trouve=nb*3;
    return new_data;
}

unsigned int *__indice_list::select_face_out(unsigned int *data,int nb_faces,int *nb_trouve)
{
  int i,nb;
  unsigned int *new_data;
  new_data=new unsigned int[nb_faces*3];

  nb=0;
  for(i=0;i<nb_faces;i++)
    {
      if((isIndiceInList(data[3*i+0])==1)&&(isIndiceInList(data[3*i+1])==1)&&(isIndiceInList(data[3*i+2])==1))
        continue;
      // Les trois indices y sont
      new_data[nb*3]=data[3*i+0];
      new_data[nb*3+1]=data[3*i+1];
      new_data[nb*3+2]=data[3*i+2];
      nb++;
    }
  *nb_trouve=nb*3;
  return new_data;
}



void write_file(char *filename,unsigned int *data,int size)
{
  FILE *File;
  File=fopen(filename,"w");
  fwrite(data,1,size*4,File);
  fclose(File);
}

// on a des faces triangulaires
void analyse_faces()
{

}


Sp_Obj_gl::Sp_Obj_gl(char *filename,Sp_Adm *gest3d,Sp_Obj *ton_pere,int priority):Sp_Obj3d(filename,gest3d,ton_pere,priority)
{
  FILE *File;
  char *tmpfilename;

  // Ouverture du fichier
  if ((tmpfilename=(char *)malloc(strlen(filename)+strlen(DATADIR)+2))==NULL)
   {
     printf("Not enought memory\n");
     return;
   }
  sprintf(tmpfilename,"%s/%s",DATADIR,filename);
  File=fopen(tmpfilename,"rb");
  free(tmpfilename);

  // taille du fichier
  int size;
  fseek(File,0,SEEK_END);  
  size=ftell(File);  
  fseek(File,0,SEEK_SET);

  int i;
  Sp_EntityMultiplexe *entity=new Sp_EntityMultiplexe(this);
  entity->Init_Data(size/(4*8),GL_T2F_N3F_V3F);
  fread((void *)entity->data,1,size,File);
  fclose(File);

  float *donnees=(float *)entity->data;
        // We are scaling DATA
    for(i=0;i<(size/32);i++){
        donnees[8*i+5]=donnees[8*i+5]*SCALE;
        donnees[8*i+6]=donnees[8*i+6]*SCALE;
        donnees[8*i+7]=donnees[8*i+7]*SCALE;
    }


        // la taille du fichier en float
  size/=4;
  int k,j;
  




// pour un point, on a 8 float decoupe comme ci dessous
       // 2 de textures
       // 3 de normales
       // 3 de point
  // entity est une suite de ces groupements
  // ici le contour du circuit est en 8 points
  // d ou 8*8 decrit un contour

  float texture_depth=0;
  float step=0.1;

  int begin_pts=0;
  int nb_pts=size/8;
  
  for(k=begin_pts;k<nb_pts;k+=NB_PT_CONTOUR)
  {
      i=k*8;
          // point 0
      entity->data[i]=0.0;
      entity->data[i+1]=texture_depth;
      
          // point 1
      entity->data[i+8]=0.2;
      entity->data[i+9]=texture_depth;
      
          //point 2
      entity->data[i+16]=0.8;//0;
      entity->data[i+17]=texture_depth;
      
          // point 3
      entity->data[i+24]=1.0;//0.1;
      entity->data[i+25]=texture_depth;
      
          // point 4
      entity->data[i+32]=0.9;//0.9;
      entity->data[i+33]=texture_depth;
      
          // point 5
      entity->data[i+40]=0.8;//1;
      entity->data[i+41]=texture_depth;
      
          // point 6
      entity->data[i+48]=0.2;//0.9;
      entity->data[i+49]=texture_depth;
      
          // point 7
      entity->data[i+56]=0.1;
      entity->data[i+57]=texture_depth;
      
          //point 8
          // entity->data[i+64]=0.8;
          //entity->data[i+65]=0;
      
      
          // on avance i

      texture_depth=texture_depth+step;
          //while(texture_depth>1)
          //texture_depth-=1;
    }
  
  

//12096

#ifdef UNE_FACE_SUR_2
  int nb2;
  nb2=CST/2;
  unsigned int *data2;
  data2=new unsigned int[CST/2];
  // ici on trouve la liste des index (triangles)
  for(i=0;i<nb2;i+=3)
    {
      data2[i]=GL3DS_INDEX_sracer2006[2*i];
      data2[i+1]=GL3DS_INDEX_sracer2006[2*i+1];
      data2[i+2]=GL3DS_INDEX_sracer2006[2*i+2];
    }
#endif
#ifndef UNE_FACE_SUR_2 
    int nb2;
    nb2=CST;
    unsigned int *data2;
    data2=GL3DS_INDEX_sracer2006;
#endif

  // un epurateur permet de selectionner des faces 
  __indice_list epurateur(NB_PT_CONTOUR); // nb de points dans le contour
  epurateur.Add_Indice(6);
  epurateur.Add_Indice(4);
  epurateur.Add_Indice(5);
  epurateur.Add_Indice(7);
  epurateur.Add_Indice(3);
  epurateur.Add_Indice(0);

// 2
      // epurateur.Add_Indice(7);
    

  // Dans ce cas, on selectionne les faces qui ne contiennent pas les
  // points indices dans l epurateur
  Sp_GEntityMulti *current;
  current=new Sp_GEntityMulti(entity);
  current->type=GL_TRIANGLES;
  current->data=epurateur.select_face_out(data2,nb2/3,&current->nb);
  current->num_tex=gest3d->Load_texture("texture2.png");
  // svg dans un fichier
  printf("nb:%i\n",current->nb);
  write_file("sracer.fa1",current->data,current->nb);  
  entity->Add_GEntity(current);

  // Dans ce cas, on selectionne les faces qui contiennent les
  // points indices dans l epurateur  
  current=new Sp_GEntityMulti(entity);
  current->type=GL_TRIANGLES;
  current->data=epurateur.select_face_in(data2,nb2/3,&current->nb);
  current->num_tex=gest3d->Load_texture("texture4.png");
  // svg dans un fichier
  printf("nb:%i\n",current->nb);
  write_file("sracer.fa2",current->data,current->nb);  
  entity->Add_GEntity(current);

  Add_Entity(entity);

  // We're creating ojects for the physics
  for(i=begin_pts;i<NB_PT_CONTOUR*2;i++){
      printf("%f %f %f \n",
             entity->data[i*8+5],
             entity->data[i*8+6],
             entity->data[i*8+7]);    
  }
  
  
}

void Sp_Obj_gl::Draw()
{
  typedef list<Sp_EntityBase *>::iterator iter;
  
  for(iter i=list_entities.begin();i!=list_entities.end();i++)
    {
      (*i)->Draw();
    }
}

void Sp_Obj_gl::Work()
{
  Draw();
}



Sp_Load_CircuitC::Sp_Load_CircuitC(char *filename)
        :Sp_CircuitC()
{
  FILE *File;
  char *tmpfilename;

  // Ouverture du fichier
  if ((tmpfilename=(char *)malloc(strlen(filename)+strlen(DATADIR)+2))==NULL)
   {
     printf("Not enought memory\n");
     return;
   }
  sprintf(tmpfilename,"%s/%s",DATADIR,filename);
  File=fopen(tmpfilename,"rb");
  free(tmpfilename);
  if(File==0){
     printf("Le fichier %s ne s ouvre pas\n",filename);
     exit(0);
  }

  // taille du fichier
  int size;
  fseek(File,0,SEEK_END);  
  size=ftell(File);  
  fseek(File,0,SEEK_SET);

  int i;
    float *donnees=new float[size/4];
    fread((void *)donnees,1,size,File);
    fclose(File);

        // We are scaling DATA
    for(i=0;i<(size/32);i++){
        donnees[8*i+5]=donnees[8*i+5]*SCALE;
        donnees[8*i+6]=donnees[8*i+6]*SCALE;
        donnees[8*i+7]=donnees[8*i+7]*SCALE;
    }
    

    
        // definition de la GEntity
#ifdef UNE_FACE_SUR_2
    int nb2;
    nb2=CST/2;
    unsigned int *data2;
    data2=new unsigned int[CST/2];
        // ici on trouve la liste des index (triangles)
    for(i=0;i<nb2;i+=3)
    {
        data2[i]=GL3DS_INDEX_sracer2006[2*i];
        data2[i+1]=GL3DS_INDEX_sracer2006[2*i+1];
        data2[i+2]=GL3DS_INDEX_sracer2006[2*i+2];
    }
#endif
#ifndef UNE_FACE_SUR_2
    int nb2;
    nb2=CST;
    unsigned int *data2;
    data2=GL3DS_INDEX_sracer2006;
#endif
        // un epurateur permet de selectionner des faces 
    __indice_list epurateur(NB_PT_CONTOUR); // nb de points dans le contour
  epurateur.Add_Indice(6);
  epurateur.Add_Indice(4);
  epurateur.Add_Indice(5);
  epurateur.Add_Indice(7);
  epurateur.Add_Indice(3);
  epurateur.Add_Indice(0);


        // epurateur.Add_Indice(7);
    
    
    unsigned int *data; int nb;
        // dans data on trouve les faces selectionnees
    data=epurateur.select_face_in(data2,nb2/3,&nb);

        // on cree les FaceC
    Sp_FaceC *face_cur;
    for(i=0;i<nb;i+=3){
            //printf("%d %d %d \n",data[i+0],data[i+1],data[i+2]);
        face_cur=new Sp_FaceC(&donnees[(data[i]*8)+5],&donnees[(data[i+1]*8)+5],&donnees[(data[i+2]*8)+5]);
        Add_Face(face_cur);
    }
       

        // We are computing Neighbours
    ComputeNeighbours();
    
}
