#include "texgl.h"
#include <GL/glut.h>
#include <stdio.h>

/* Le code pour gerer les textures */ 

TexturesGL::TexturesGL()
{
  auto_texture=0;
}

/* Cree une texture identifier par la valeur de retour  */
/* Sa taille doit etre multiple de 2 et son format RGBA */
int TexturesGL::Create(unsigned char *texture,int w,int h)
{
  auto_texture++;
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, auto_texture);
  gluBuild2DMipmaps(GL_TEXTURE_2D,4,w,h,GL_RGBA,GL_UNSIGNED_BYTE,texture);
  return 0;
}


/* Cree une texture a partir d un fichier BMP24bits */
/* h et w doivent etre multiple de 2 */
int TexturesGL::LoadTex_FromBMP24(char *name,int w,int h)
{
  FILE *fichier;
  unsigned char *texture,*texture2;
  int i;
  
  texture= new unsigned char[w*h*4];
  texture2=new unsigned char[w*h*3]; 
  fichier=fopen(name,"rb");
  // On saute les entetes bmp
  fseek(fichier,56,SEEK_SET);
  fread(texture2,w*h*3,1,fichier);
  for(i=0;i<w*h;i++){
    texture[i*4]=texture2[3*w*h-i*3-3];
    texture[i*4+1]=texture2[3*w*h-i*3-1];
    texture[i*4+2]=texture2[3*w*h-i*3-2];
    texture[i*4+3]=255;
  }
  Create(texture,w,h);
  delete texture;
  delete texture2;
	return 0;
}
