#include "sp_car.h"


#define DISTANCE_AU_SOL 3


Sp_Car::Sp_Car(char *name,Sp_Adm *gest3d,Sp_Obj *ton_pere):Sp_Camera(name,gest3d,ton_pere)
{
    position=new Sp_Trans(gest3d);
    trans->Add_Trans(position);
}

void Sp_Car::Init(Sp_CircuitC *c,Sp_Point &p,Sp_Vecteur &direction)
{
        // le circuit courant
    circuit=c;
        // on trouve la face courante
    face=find_init(p);
    if(face==0){
        face=*(c->list_faces.begin());
        O=face->Center();
    }
    
        // on cherche le point de depart
    O=face->Project(p);
    O=face->Center();
    
        // On construit le 1er repere
    Sp_Vecteur vnull(0,0,0);
    k=vnull-face->Normale();
    i=face->Project(direction);
        //Sp_Vecteur ji=k^direction;
    Sp_Vecteur    ji=k^i;
    k.Norme();
    ji.Norme();
    i.Norme();

    Sp_Point OH;
    OH=O+k*DISTANCE_AU_SOL;
    
    position->Set(ji,k,i,OH);
        /*
    trans->tab[0]=ji.x; trans->tab[4]=ji.y; trans->tab[8]=ji.z;
    trans->tab[1]=k.x; trans->tab[5]=k.y; coord->tab[9]=k.z;
    trans->tab[2]=i.x; trans->tab[6]=i.y; coord->tab[10]=i.z;
    trans->tab[3]=O.x+DISTANCE_AU_SOL*k.x;
    trans->tab[7]=O.y+DISTANCE_AU_SOL*k.y;
    trans->tab[11]=O.z+DISTANCE_AU_SOL*k.z; 
        */
}


void Sp_Car::Work(void){
  vspeed*=0.95;     // suuuuper stupid slowdown
  Compute_Next_Postion(0,1);
}

void Sp_Car::Accelerate(float value)
{
  // no speed limit...  ;)
  // linear acceleration :(
  vspeed+=value;
}

    
    // Calcule next position
void Sp_Car::Compute_Next_Postion(float speed,float elapsed)
{
    
        // compute distance
    float distance;
    distance=vspeed*elapsed;

        // Projette the direction vector
    Sp_Vecteur direction=face->Project(i);
    direction.Norme();
    
        // Compute Next Point
    Sp_Point P1;
    P1=O+direction*distance;
    P1=face->Project(P1);

    if(face->IsIn(O)==0){
      //        printf("pb tres grave\n");
        exit(0);
    }

    //  face->Print2();
    
    
    if(face->IsIn(P1)!=0){
        O=P1;
    } else {

        Sp_Point intersection(0,0,0);
        Sp_FaceC *new_face=face;
        
        if(face->WhichCut(O,P1,intersection,&new_face)==0){
	  //            printf("pb d intersection\n");
            exit(0);
        }
        if(new_face==0){
	  //            printf("putain qu est ce qu il se passe???\n");
            exit(0);
        }
        
            // we are computing the distance realized
        float distance_todo;
        float distance_done=(O-intersection).Compute_norme();
        if(distance<0){
            distance_todo=distance+distance_done;
        } else {
            distance_todo=distance-distance_done;
        }
        
           
        if(face==new_face){
	  //            printf("on change pas de face\n");
            exit(0);
        }
        
        face=new_face;
        i=face->Project(i);
        i.Norme();
        O=intersection+i*distance_todo;
    }

    Sp_Vecteur vnull(0,0,0);
    k=vnull-face->Normale();
    
    Sp_Vecteur    ji=k^i;
    k.Norme();
    ji.Norme();
    i.Norme();
        //  printf("ji\n");
        // ji.Print();
    
    /*
    coord->tab[0]=ji.x; coord->tab[4]=ji.y; coord->tab[8]=ji.z;
    coord->tab[1]=k.x;  coord->tab[5]=k.y;  coord->tab[9]=k.z;
    coord->tab[2]=i.x;  coord->tab[6]=i.y;  coord->tab[10]=i.z;
    coord->tab[3]=O.x+DISTANCE_AU_SOL*k.x;
    coord->tab[7]=O.y+DISTANCE_AU_SOL*k.y;
    coord->tab[11]=O.z+DISTANCE_AU_SOL*k.z; */
        // coord->Print();
    Sp_Point OH;
    OH=O+k*DISTANCE_AU_SOL;
    position->Set(ji,k,i,OH);
}






Sp_FaceC *Sp_Car::find_init(Sp_Point &P)
{
    typedef vector<Sp_FaceC *>::iterator iter;
    Sp_FaceC *solution=0;
    float    distance=1e10;

        //  printf(" le point face plus proche\n");
    
        // P.Print();
    
    for(iter i=circuit->list_faces.begin();i!=circuit->list_faces.end();i++)
    {
            // We're testing if the point P is in the face
        if((*i)->IsIn(P)!=0)
        {
                //printf("face trouvee\n");
                //(*i)->Print();
            Sp_Point center=(*i)->Center();
            float d2=P.Distance(center);
            if(d2<distance)
            {
                distance=d2;
                solution=(*i);
            }
        }     
    }
        // la face trouve
        // printf("face solution\n");
        // printf("distance%f\n",distance);
        //solution->Print();
    
    return solution;
}

