/*****************************************************************
 * Space Racer 3.0    in OpenGl       By Ellis                   *
 * By Ellis & Gollum (c) Thunder Folks 1997 for version 1 and 2  *
 * Derniere Version au 04/04/1999                                *
 * Version         Linux                                         *
 *****************************************************************/



#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <GL/glut.h>

// Mes includes
#include "fontgl.h"
#include "cobj.h"
#include "stars.h"
#include "planets.h"
#include "loadgl.h"
#include "sp_car.h"
#include "sp_circuit.h"

// Les variables globales
// La taille de la fenetre
int  Sp_width,Sp_height;
// La touche enfoncee
int Sp_key;
int Sp_pressed_keys=0;
// Le Mode 0:menu principal 1: play
int Sp_mode;


void Sp_main();



/* La fonction d initialisation de Space Racer
   Elle initialise le mode OpenGL
 */
void Sp_init(void)
{
        // On n effectue pas d eclairage
  glDisable(GL_LIGHTING);
  
  // On active le Z buffer
  glEnable(GL_DEPTH_TEST);

  
  // On definit la projection
  // On utilise une projection perspective
  glMatrixMode(GL_PROJECTION);
  gluPerspective( /* angle de vue en degree */ 40.0,
                  /* coef de zoom */ 1.0,
                  /* Z near */ 1.0, /* Z far */ 10000.0);
  // On definit le placement de la camera
  glMatrixMode(GL_MODELVIEW);
  gluLookAt(0.0, 0.0, 2.5,      /* oeil a (0,0,5) */
            0.0, 0.0, -2.5,      /* centre  a (0,0,0) */
            0.0, 1.0, 0.);      /* le haut correspond au Y positif  */
  Sp_width=640;
  Sp_height=480;
  Sp_mode=0;
}





/* ***********************************************************************************

   LE CODE PORTAGE

**************************************************************************************/


void MenuPrincipal(void);
void Play(void);


/* Gestion des evenements */
#define SP_KEY_EVENT 1
#define SP_REFRESH_EVENT 1<<31
int Sp_event=SP_REFRESH_EVENT;

// Key-pressed masks
#define SP_KEY_LEFT  1
#define SP_KEY_RIGHT 2
#define SP_KEY_UP 4
#define SP_KEY_DOWN 8


void Sp_main()
{
  // On efface le color buffer
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* si on a un event */
  if(Sp_event!=0){
    switch(Sp_mode){
    case 0:
      MenuPrincipal();
      break;
    case 1:
      Play();
      break;
    }
    
  }

  // On efface les evenements
  Sp_event=0;
  // on flipe
  glutSwapBuffers();
}



/* variables concernant le mode play */
Sp_Adm *gest3d;
Sp_Obj_stars *etoiles;
int neige;
Sp_Camera *objf;
Sp_Camera *objf2;
Sp_Car *objf3;
Sp_Obj_gl *circuitnew;
Sp_Load_CircuitC *circuitphy;


/* Initialisation du mode play */
void Init_Play()
{
  glEnable(GL_TEXTURE_2D);
  gest3d=new Sp_Adm("Gestionnaire 3d");
  etoiles=new Sp_Obj_stars("stars.dat",gest3d,gest3d,SP_FIRST_3DPRIORITY);
  Sp_Load_Planetes(gest3d,gest3d);
  //objf=new Sp_Camera("la camera du circuit",gest3d,circuit);
  objf2=new Sp_Camera("la camera du gest",gest3d,gest3d);
  objf3=new Sp_Car("la voiture du gest",gest3d,gest3d);
  circuitnew=new Sp_Obj_gl("sracer2006.gl",gest3d,gest3d,SP_NORMAL_3DPRIORITY);
  circuitphy=new Sp_Load_CircuitC("sracer2006.gl");
  Sp_Point dep(5,0,0.0);
  Sp_Vecteur dir(0,0,1);
  objf3->Init(circuitphy,dep,dir);
  
}

/* Quit du mode play */
void Quit_Play()
{
  glDisable(GL_TEXTURE_2D);
  Sp_Delete_Planetes();
  delete gest3d;
}

/* Mode Play */
void Play()
{
        //glPushMatrix();
    
  static    Sp_Mat4 titi;  //avoid constructor in inner loop
  static    Sp_Mat4 toto;
  if((Sp_event&SP_KEY_EVENT)==1)
    {
        switch(Sp_key){
            case '0':
                    // on quitte le mode play
                Quit_Play();
                Sp_mode=0;
                return;
            case '8':
                objf3->Compute_Next_Postion(-1,1);
                break;
            case '2':
                objf3->Compute_Next_Postion(1,1);
                break;
                

            case '4':
                titi.SetY(-5.0/360);
                (Sp_Mat4&)(*objf3->position)=(*objf3->position)*titi;
                objf3->k.x=objf3->trans->result.tab[1];
                objf3->k.y=objf3->trans->result.tab[5];
                objf3->k.z=objf3->trans->result.tab[9];
                objf3->i.x=objf3->trans->result.tab[2];
                objf3->i.y=objf3->trans->result.tab[6];
                objf3->i.z=objf3->trans->result.tab[10];
                break;
            case '6': 
                toto.SetY(5.0/360);
                (Sp_Mat4&)(*objf3->position)=(*objf3->position)*toto;
                objf3->k.x=objf3->trans->result.tab[1];
                objf3->k.y=objf3->trans->result.tab[5];
                objf3->k.z=objf3->trans->result.tab[9];
                objf3->i.x=objf3->trans->result.tab[2];
                objf3->i.y=objf3->trans->result.tab[6];
                objf3->i.z=objf3->trans->result.tab[10];
                break;
                                    
        }
    }
    if(Sp_pressed_keys){
        if(Sp_pressed_keys&SP_KEY_LEFT){
            titi.SetY(-10.0/360.0);
	    (Sp_Mat4&)(*objf3->position)=(*objf3->position)*titi;
	    objf3->trans->Compute();
            objf3->k.x=objf3->trans->result.tab[1];
            objf3->k.y=objf3->trans->result.tab[5];
            objf3->k.z=objf3->trans->result.tab[9];
            objf3->i.x=objf3->trans->result.tab[2];
            objf3->i.y=objf3->trans->result.tab[6];
            objf3->i.z=objf3->trans->result.tab[10];
	}
        if(Sp_pressed_keys&SP_KEY_RIGHT){
	  toto.SetY(10.0/360.0);
	  (Sp_Mat4&)(*objf3->position)=(*objf3->position)*toto;
	  objf3->trans->Compute();
          objf3->k.x=objf3->trans->result.tab[1];
          objf3->k.y=objf3->trans->result.tab[5];
          objf3->k.z=objf3->trans->result.tab[9];
          objf3->i.x=objf3->trans->result.tab[2];
          objf3->i.y=objf3->trans->result.tab[6];
          objf3->i.z=objf3->trans->result.tab[10];
        }
        if(Sp_pressed_keys&SP_KEY_UP){
	    objf3->Accelerate(-0.2);
	}
        if(Sp_pressed_keys&SP_KEY_DOWN){
	  objf3->Accelerate(0.2);
	}
    }
    static float j;
        //j+=0.1;
        //Sp_Mat4 titi;
        //titi.SetY(1.0/360);
        //objf2->trans->result->Print();
        //(*circuit->trans->result)=(*circuit->trans->result)**titi;
    gest3d->camera_active=objf3;
    gest3d->DrawScene();
    
        //glPopMatrix();  
    
}




/* choice indique la position du curseur ie choix courant */
void MenuPrincipal()
{
  static int choice=0;
  if((Sp_event&SP_KEY_EVENT)==1)
    {
      switch(Sp_key){
      case '8':
      case GLUT_KEY_UP:
        if(choice>0)
          choice--;
        break;
      case GLUT_KEY_DOWN:
      case '2':
        if(choice<4)
          choice++;
        break;
      case 13:
        // On a appuye sur entree
        // analyse du choix
        switch(choice){
        case 0:
          Init_Play();
          Sp_mode=1;
          break;
        case 4:
          //on quitte
          exit(0);
            break;
        }
        break;
      default:
        printf("%d\n",Sp_key);
        break;
      }
    }
  // Affichage du menu principal
  MsgGL  msg(Sp_width,Sp_height);
  msg.TakeC();
  msg.Printf(">",200,100+choice*40);
  msg.Printf("<",390,100+choice*40);
  msg.Printf("Nouveau Jeu",240,100);
  msg.Printf("Options",263,140);
  msg.Printf("A propos",258,180);
  msg.Printf("HighScores",245,220);
  msg.Printf("Quitter",265,260);  
  msg.RendreC();


}







/* ***********************************************************************************

   FIN DU CODE PORTAGE

**************************************************************************************/




/* Activation d une touche */
void key(unsigned char c, int x, int y)
{
  Sp_event|=SP_KEY_EVENT;
  Sp_key=c;
  //printf("key");
  //Sp_main();
  glutPostRedisplay();
}

void specialkey(int c,int x, int y)
{
  if(Sp_mode){
    switch(c){
    case GLUT_KEY_UP:
      Sp_pressed_keys|=SP_KEY_UP;
      break;
    case GLUT_KEY_DOWN:
      Sp_pressed_keys|=SP_KEY_DOWN;
      break;
    case GLUT_KEY_LEFT:
      Sp_pressed_keys|=SP_KEY_LEFT;
      break;
    case GLUT_KEY_RIGHT:
      Sp_pressed_keys|=SP_KEY_RIGHT;
      break;
    default:
      Sp_event|=SP_KEY_EVENT;
      Sp_key=c;
    }
  }
  else{
    // We're in menu-mode
    Sp_event|=SP_KEY_EVENT;
    Sp_key=c;
  }
  glutPostRedisplay();
}
void specialkeyup(int c,int x, int y)
{
  if(Sp_mode){
    switch(c){
    case GLUT_KEY_UP:
      Sp_pressed_keys&=~SP_KEY_UP;
      break;
    case GLUT_KEY_DOWN:
      Sp_pressed_keys&=~SP_KEY_DOWN;
      break;
    case GLUT_KEY_LEFT:
      Sp_pressed_keys&=~SP_KEY_LEFT;
      break;
    case GLUT_KEY_RIGHT:
      Sp_pressed_keys&=~SP_KEY_RIGHT;
      break;
    }
    glutPostRedisplay();
  }
}

/* rien ne se passe */
void idle(void)
{
    static int start=0;
    static int end;
    end = glutGet((GLenum)GLUT_ELAPSED_TIME);
    
  if((end-start)>10)    {
      if(Sp_mode==1){
              printf("fps:%d\n",1000/(end-start));
      }
      
      start = end ;	
      Sp_event|=SP_REFRESH_EVENT;
      glutPostRedisplay();
  }
  else{
      struct timeval tv;
      tv.tv_sec = 0;
      tv.tv_usec = 10;
          //  select(1, NULL, NULL, NULL, &tv);     
  }
}

/* deplacement de la souris */
void mouse(int button, int state, int x, int y)
{
  Sp_event|=SP_REFRESH_EVENT;
  //  glutPostRedisplay();
}


/* When not visible */
void  visible(int vis)
{
  Sp_event|=SP_REFRESH_EVENT;
  glutPostRedisplay();
}


/* quand on redimensionne la fenetre */
void reshape(int w, int h)
{
  Sp_event|=SP_REFRESH_EVENT;
  glutReshapeWindow(640,480); 
  glutPostRedisplay();
}


int main(int argc, char **argv)
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutInitWindowSize(640, 480);
  glutCreateWindow("Space Racer 3.0 in OpenGL");
  glutDisplayFunc(Sp_main);
  glutReshapeFunc(reshape);
  glutMouseFunc(mouse);
  glutVisibilityFunc(visible);
  glutKeyboardFunc(key); 
  glutSpecialUpFunc(specialkeyup);
  glutSpecialFunc(specialkey);
  glutIdleFunc(idle);	
  // on met la couleur du buffer apres effacement au noir
  glClearColor(0,0, 0, 0);
  Sp_init();
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_BLEND);
  // On passe dans la boucle glut
  //  titu=GL3DS_initialize_test1();
  glutMainLoop();
  return 0;      
}
